% MLB KU WS10


clear all
close all

addpath('./gatoolbox')

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% set error function

fname = 'Rastrigin';
%  fname = 'Rosenbrock';
%  fname = 'Ackley';
%  fname = 'Chasm';


switch fname
case 'Rastrigin'
  error = @(x)( squeeze(sum( x.^2 + 10 - 10*cos(2*pi*x),1)) ) ;
  xbound = [-1, 1; -1 ,1]*5;
case 'Rosenbrock'
  error = @(x)( 1*(squeeze(x(2,:,:,:)-x(1,:,:,:).^2)).^2 + ...
                     (squeeze(x(1,:,:,:))-1).^1/2  + ...
                       2*squeeze(sum(abs(x-1.5),1)));
  xbound = [-1, 1; -1 ,1]*2;
case 'Ackley'
  error = @(x)( exp(1) + 20 - ...
                  20*exp(-0.2*sqrt(1/2*squeeze(sum(x.^2,1)))) - ...
                     exp(0.5*squeeze(sum(cos(2*pi*x),1))) );
  xbound = [-4, 4; -4 ,4]*2;
case 'Chasm'
1
  error = @(x)( squeeze(1e3*abs(x(1,:,:,:))./(1e3*abs(x(1,:,:,:))+1)+ 1e-2*abs(x(2,:,:,:))));
  xbound = [-1, 1; -1 ,1]*5;
end

% visualization

dx = 0.1;
[X,Y] = meshgrid( xbound(1):dx:xbound(3), xbound(2):dx:xbound(4) );
XY = permute(cat(3,X,Y),[3 1 2]);
Z = error(XY);

figure
surf(X,Y,Z)
title(fname)

disp('Key ...')
pause


nTRIALS = 10;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% gradient descent 


E1 = [];
for nt = 1:nTRIALS
   fprintf('Trial: %i/%i\n',nt,nTRIALS)

   x = rand(size(xbound,1),1) .* diff(xbound,[],2) + min(xbound,[],2);

   eta = 1e-1;
   dx = 1e-3;
   itermax = 2000;

   e = [];
   tic
   for iter = 1:itermax

     ... HOMEWORK ...

     e(iter) = error(x);
   end
   t1(nt) = toc;

   E1(nt) = e(itermax);
   
end

figure
plot(e)

figure
surf(X,Y,Z)
title(fname)
hold on
plot3(x(1),x(2),E1(end),'r.','markersize',50)





%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% SIMULATED ANNEALING

% Set SA options (see help anneal)
options.Verbosity = 0;
options.CoolSched = @(T)( ... HOMEWORK ... );
options.Generator = @(x) ( ... HOMEWORK ... );
options.StopTemp =   ... HOMEWORK ... ;
options.MaxSuccess =  ... HOMEWORK ... ;
options.MaxConsRej =  ... HOMEWORK ... ;
options.MaxTries =  ... HOMEWORK ... ;
options.MaxIter =  ... HOMEWORK ... ;

E2 = [];
for nt = 1:nTRIALS
   fprintf('Trial: %i/%i\n',nt,nTRIALS)

   x = rand(size(xbound,1),1) .* diff(xbound,[],2) + min(xbound,[],2);

   tic

     ... HOMEWORK ...  (implement anneal.m, output best solution x)
     [x, annealstat{nt}] = anneal(...);


   t2(nt) = toc;

   E2(nt) = error(x);
end


figure
surf(X,Y,Z)
title(fname)
hold on
plot3(x(1),x(2),E2(end),'r.','markersize',50)





%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% GENETIC ALGORITHMS


NUM_GENERATIONS = ... HOMEWORK ... ;
POPULATION_SIZE = ... HOMEWORK ... ;
DISPLAY = 0;

E3 = [];
for nt = 1:nTRIALS
   fprintf('Trial: %i/%i\n',nt,nTRIALS)

   x = rand(size(xbound,1),1) .* diff(xbound,[],2) + min(xbound,[],2);

   % note that GA maximizes the fitness function -error
   estr = strrep(func2str(error),'@(x)','-');
   startPop = initializega(POPULATION_SIZE,xbound,estr,[1e-6      1 DISPLAY 1e-1]);

   tic

     ... HOMEWORK ...  (implement ga.m, output best solution x)
         (use the same estr variable as in initializega above )

    [sol,endPop,bPop,traceInfo] = ga( ... );

   t3(nt) = toc;

   x = sol(1:end-1)';
   E3(nt) = error(x);
   
end


figure
surf(X,Y,Z)
title(fname)
hold on
plot3(x(1),x(2),E3(end),'r.','markersize',50)




%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% PSO


nparticles = ... HOMEWORK ...;
maxiter = ... HOMEWORK ...;
maxconsfail = ... HOMEWORK ...;
params = ... HOMEWORK ...;

E4 = [];
for nt = 1:nTRIALS
   fprintf('Trial: %i/%i\n',nt,nTRIALS)

   x = rand(size(xbound,1),1) .* diff(xbound,[],2) + min(xbound,[],2);

   tic
   [x] = pso(xbound,nparticles,error,maxiter, maxconsfail,params);
   t4(nt) = toc;

   E4(nt) = error(x);
end


figure
surf(X,Y,Z)
title(fname)
hold on
plot3(x(1),x(2),E4(end),'r.','markersize',50)









%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% PLOT RESULTS

figure
subplot(221)
bar(mean([E1',E2',E3',E4']))
hold on
errorbar(mean([E1',E2',E3',E4']),std([E1',E2',E3',E4'])/sqrt(nTRIALS),'k.')
title('Performance')
xlabel('Algorithm')
ylabel('Average error')
set(gca,'xticklabel',{'GD','SA','GA','PSO'})

subplot(222)

bar(mean([t1',t2',t3',t4']))
hold on
errorbar(mean([t1',t2',t3',t4']),std([t1',t2',t3',t4'])/sqrt(nTRIALS),'k.')
title('Cost')
xlabel('Algorithm')
ylabel('Average run time')
set(gca,'xticklabel',{'GD','SA','GA','PSO'})

